<?php



# $Id: handler-prefix.php,v 1.3 2002/04/14 19:01:15 jimmerman Exp $



// Written by James Flemer

// For eGrad2000.com

// <jflemer@acm.jhu.edu>

// <jflemer@eGrad2000.com>



/* When using the authentication for responses you need to include

 * part of the script *before* your template so that the

 * HTTP Auth headers can be sent when needed.

 *

 * So, create your template file with this as the *first*

 * line:

 *   <?php $sid=<SID>; include('.../phpESP/public/authhand-prefix.php'); ?>

 * then where you want to include the actual survey use this

 * line:

 *   <?php inlcude('.../phpESP/public/authhand-suffix.php'); ?>

 *

 * For example, here is a very small template:

 *   <?php $sid=42; include('phpESP/public/authhand-prefix.php'); ?>

 *   <html>

 *   <head><title>Speednaked.com</title></head>

 *   <body>

 *   <table border="0" width="800">

 *   <tr><td colspan="2"><img src="speednaked-banner.png" 

 *       border="0" width="800" height="42"></td></tr>

 *   <tr><td><?php inlcude('speednaked-sidebar.php'); ?></td>

 *       <td><?php include('phpESP/public/authhand-suffix.php'); ?>

 *       </td>

 *   </tr>

 *   <tr><td colspan="2"><p align="right"><font size="-2">

 *       Copyright &copy; 2001. Speednaked.com</font></p></td></tr>

 *   </table>

 *   </body>

 *   </html>

 *   

 */



if(!defined('AUTHHAND-PREFIX')) {

	define('AUTHHAND-PREFIX', TRUE);

	// undefine('AUTHHAND-OK');

	

//	require('/chs/p3/querytek.com/home/data/esp/admin/phpESP.ini');

	require("$path_local/data/$carpeta_version/admin/phpESP.ini");

	require($ESPCONFIG['include_path']."/funcs".$ESPCONFIG['extension']);

	

	$GLOBALS['errmsg'] = '';



	if(isset($_GET['sid'])) {

		$GLOBALS['errmsg'] = mkerror(_('Error processing survey: Security violation.'));

		return;

	}

	

	if(isset($_GET['results']) || isset($_POST['results'])) {

		$GLOBALS['errmsg'] = mkerror(_('Error processing survey: Security violation.'));

		return;

	}



	if (isset($sid) && !empty($sid))

		$sid = intval($sid);

	else if (isset($_POST['sid']) && !empty($_POST['sid']))

		$sid = intval($_POST['sid']);



	if(!isset($sid) || empty($sid)) {

		$GLOBALS['errmsg'] = mkerror(_('Error processing survey: Survey not specified.'));

		return;

	}



	if(empty($_POST['userid'])) {

		// find remote user id (takes the first non-empty of the following)

		//  1. a GET variable named 'userid'

		//  2. the REMOTE_USER set by HTTP-Authentication

		//  3. the query string

		//  4. the remote ip address

		if (!empty($_GET['userid'])) {

			$_POST['userid'] = $_GET['userid'];

		} elseif(!empty($_SERVER['REMOTE_USER'])) {

			$_POST['userid'] = $_SERVER['REMOTE_USER'];

		} elseif(!empty($_SERVER['QUERY_STRING'])) {

			$_POST['userid'] = urldecode($_SERVER['QUERY_STRING']);

		} else {

			$_POST['userid'] = $_SERVER['REMOTE_ADDR'];

		}

	}



	if(empty($_POST['referer']))

		$_POST['referer'] = isset($_SERVER['HTTP_REFERER']) ?

			$_SERVER['HTTP_REFERER'] : '';



	if(empty($_POST['sec']) || $_POST['sec'] < 1) {

		$_POST['sec'] = 1;



		if($ESPCONFIG['auth_response']) {

			// check for authorization on the survey

			include($ESPCONFIG['include_path']."/lib/espauth".$ESPCONFIG['extension']);

			if(!survey_auth(

					$sid, 

					addslashes($_SERVER['PHP_AUTH_USER']),

					addslashes($_SERVER['PHP_AUTH_PW'])))

				return;

		}

	}

	define('AUTHHAND-OK', TRUE);

} /* !defined('AUTHHAND-PREFIX') */

?>

